/*
Module : IPenum.h
Purpose: Interface for an class wrapper to get the details of all network adapters installed on your computer
Created: PJN / 21-04-1998

Copyright (c) 1997 - 2022 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code. 

*/


//////////////////// Macros / Defines /////////////////////////////////////////

#pragma once

#ifndef __IPENUM_H__
#define __IPENUM_H__


//////////////////// Includes /////////////////////////////////////////////////

#ifndef _WINSOCK2API_
#pragma message("To avoid this message, please put winsock2.h in your pre compiled header (normally stdafx.h)")
#include <winsock2.h>
#endif //#ifndef _WINSOCK2API_

#ifndef __IPHLPAPI_H__
#pragma message("To avoid this message, please put iphlpapi.h in your pre compiled header (normally stdafx.h)")
#include <iphlpapi.h>
#endif //#ifndef __IPHLPAPI_H__

#ifndef _VECTOR_
#pragma message("To avoid this message, please put vector in your pre compiled header (normally stdafx.h)")
#include <vector>
#endif //#ifndef _VECTOR_


//////////////////// Classes //////////////////////////////////////////////////

class CIPEnum
{
public:
//Methods
  PIP_ADAPTER_ADDRESSES Enumerate(_In_ ULONG Family = AF_UNSPEC, _In_ ULONG Flags = 0, _In_ DWORD dwMaxTries = 3);

protected:
//Member variables
  std::vector<BYTE> m_Addresses;
};

#endif //#ifndef __IPENUM_H__
